unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ComCtrls;

type
  TRGBArray = array[0..32767] of TRGBTriple; 
  PRGBArray = ^TRGBArray;

  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    { Private declarations }
    FRegion: THandle;
    function CreateRegion(Bmp: TBitmap): THandle;
    procedure WMNCHitTest(var msg:TMessage); message WM_NCHITTEST;
    procedure WMPaint(var Message: TMessage);message WM_Paint;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Bmp: TBitmap;


implementation

{$R *.DFM}

procedure TForm1.WMNCHitTest(var msg:TMessage);
begin
  inherited; //process @, dImsg
  if msg.Result=HTCLIENT then msg.Result:=HTCAPTION;
end;


function TForm1.CreateRegion(Bmp: TBitmap): THandle;
var
  X, Y, StartX: Integer;
  Excl: THandle;
  Row: PRGBArray;
  TransparentColor: TRGBTriple;
begin
  Bmp.PixelFormat := pf24Bit;

  Result := CreateRectRGN(0, 0, Bmp.Width, Bmp.Height);

  for Y := 0 to Bmp.Height - 1 do 
  begin 
    Row := Bmp.Scanline[Y]; 

    StartX := -1; 

    if Y = 0 then 
    begin 
      TransparentColor := Row[0]; 
    end; 

    for X := 0 to Bmp.Width - 1 do 
    begin 
      if (Row[X].rgbtRed = TransparentColor.rgbtRed) and 
         (Row[X].rgbtGreen = TransparentColor.rgbtGreen) and 
         (Row[X].rgbtBlue = TransparentColor.rgbtBlue) then 
      begin 
        if StartX = -1 then StartX := X; 
      end else 
      begin 
        if StartX > -1 then 
        begin 
          Excl := CreateRectRGN(StartX, Y, X + 1, Y + 1); 
          try 
            CombineRGN(Result, Result, Excl, RGN_DIFF); 
            StartX := -1; 
          finally 
            DeleteObject(Excl); 
          end; 
        end; 
      end; 
    end; 

    if StartX > -1 then 
    begin 
      Excl := CreateRectRGN(StartX, Y, Bmp.Width, Y + 1); 
      try 
        CombineRGN(Result, Result, Excl, RGN_DIFF); 
      finally 
        DeleteObject(Excl); 
      end; 
    end; 
  end; 
end;



procedure TForm1.FormCreate(Sender: TObject);

begin
  
  Bmp := TBitmap.Create;
  try
    Bmp.LoadFromFile('beauty3d.bmp');
    FRegion := CreateRegion(Bmp);
    SetWindowRGN(Handle, FRegion, True); 
  finally
    //Bmp.Free;
  end;


end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  DeleteObject(FRegion);
  Bmp.Free;
end;


procedure TForm1.WMPaint(var Message: TMessage);
begin
  //if (bmp<>nil) then Canvas.Draw(0,0,TGraphic(Bmp));
  inherited;
end;


procedure TForm1.FormPaint(Sender: TObject);
begin
 Canvas.Draw(0,0,TGraphic(Bmp));
 Bitblt(Handle,0,0,Bmp.Width, Bmp.Height,Bmp.Canvas.Handle,0,0,srcpaint);
end;

end.
